
local ObjectivesBackdrop = {                         
	bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
        	edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        	tile = true, 
        	tileSize = 16, 
        	edgeSize = 16, 
        	insets = { left = 4, right = 4, top = 4, bottom = 4 }
        	};                       

--[[
local ObjectivesTextures = {
        	normal = "Interface\\Buttons\\UI-Panel-Button-Up",
        	pushed = "Interface\\Buttons\\UI-Panel-Button-Down",
        	highlight = "Interface\\Buttons\\UI-Panel-Button-Highlight",
        	disabled = "Interface\\Buttons\\UI-Panel-Button-Disabled",
        	coords = { x1 = 0.0, y1 = 0.625, x2 = 0.0, y2 = 0.6875 },
        	blend = "ADD"
        	};
--]]

local ObjectivesBackcolor = { 
        	red=0,green=0,blue=0,alpha=1 
        	};

local ObjectivesBordercolor = { 
        	red=255,green=255,blue=0,alpha=1 
        	}; 

local WatchFrameScrollFrame;

local function ResetWatchFrame()
	nUI_Options.movedWatchFrame = true;
	
	WatchFrame.moving = true;
	WatchFrame.sizing = true;
	
	WatchFrame:SetMovable( true );
	WatchFrame:SetResizable( true );
	WatchFrame:StartMoving();
	WatchFrame:StartSizing( "TOPLEFT" );
	
	WatchFrame:ClearAllPoints();
	WatchFrame:SetParent(WatchFrameScrollFrame);
	--WatchFrame:SetPoint( "BOTTOMRIGHT", WatchFrameScrollFrame, "BOTTOMRIGHT", -10, -5 );
	WatchFrame:SetPoint( "TOPLEFT", WatchFrameScrollFrame, "TOPLEFT", 10, -10 );
	WatchFrame:SetHeight( 640 ); --WatchFrameScrollFrame:GetHeight() );
	WatchFrame:SetWidth( WatchFrameScrollFrame:GetWidth() );

	WatchFrame.moving = nil;
	WatchFrame.sizing = nil;

	WATCHFRAME_IGNORECURSOR = "1";			
	WATCHFRAME_LASTWIDTH    = WatchFrameScrollFrame:GetWidth() ;
	
	WatchFrame:StopMovingOrSizing();
	WatchFrame:SetUserPlaced( true );
	WatchFrame_Expand( WatchFrame );
end

local function CreateScrollFrame()
	
	-- Frame is moving
	ObjectivesOnMouseDown = function(self)
	        if ( ( not self.isLocked ) or ( self.isLocked == 0 ) ) then
	                self:StartMoving();
	                self.isMoving = true;
		nUI_Movers:lockFrame( WatchFrame, false, nil); --OBJECTIVES_TRACKER_LABEL   );
		ResetWatchFrame();
		nUI_Movers:lockFrame( WatchFrame, true, nil );
	        end
	end

	-- Frame has stopped moving
	ObjectivesOnMouseUp = function(self)
	        if ( self.isMoving ) then
	                self:StopMovingOrSizing();
	                self.isMoving = false;
	        end
	end

	-- Frame has been hidden
	ObjectivesOnHide = function(self)
	        if ( self.isMoving ) then
	                self:StopMovingOrSizing();
	                self.isMoving = false;
	        end
	end

	-- Create Main Scroll Frame
	local f = CreateFrame( "ScrollFrame", "WatchFrameScrollFrame", UIParent, "UIPanelScrollFrameTemplate" );
	f:SetWidth(400);
	f:SetHeight(200);
	f:SetClampedToScreen(true);
	f:SetPoint("CENTER",UIParent,"CENTER",0,0);
	f:SetBackdrop(ObjectivesBackdrop);
	f:SetBackdropColor(ObjectivesBackcolor.red,ObjectivesBackcolor.green,ObjectivesBackcolor.blue, ObjectivesBackcolor.alpha);
	f:SetBackdropBorderColor(ObjectivesBordercolor.red, ObjectivesBordercolor.green,ObjectivesBordercolor.blue, ObjectivesBordercolor.alpha);
	f:RegisterForDrag(button);
	f:EnableMouse(true);
	f:SetMovable(true);
	f:SetScript("OnMouseDown",ObjectivesOnMouseDown);
	f:SetScript("OnMouseUp",ObjectivesOnMouseUp);
	f:SetScript("OnHide",ObjectivesOnHide);

	-- Create Scroll Frame Scroller Frame
	f.scroller      = CreateFrame( "Frame", "$parent_Scroller", f );	
	f.scroller:SetWidth( f:GetWidth() );
	f.scroller:SetWidth( f:GetHeight() );

	-- Tell WoW Which Frame is the Scroll child
	f:SetScrollChild( f.scroller );

	return f;
end

local plugin    = CreateFrame( "Frame", "Mini_ObjectiveFrame", UIParent );

local function onEvent()
	if event == "VARIABLES_LOADED" then
		WatchFrameScrollFrame = CreateScrollFrame();
		nUI_Movers:lockFrame( WatchFrame, false, nil); --OBJECTIVES_TRACKER_LABEL   );
		ResetWatchFrame();
		nUI_Movers:lockFrame( WatchFrame, true, nil );
	end	
end

plugin:SetScript( "OnEvent", onEvent );
plugin:RegisterEvent( "VARIABLES_LOADED" );
